#include <iostream>

using namespace std;

int x, y, n, m, nx, ny;
bool** ok;

int dx[8] = { 0, 1, 1, 1, 0, -1, -1, -1 };
int dy[8] = { 1, 1, 0, -1, -1, -1, 0, 1 };

void lts();
void xnx();
void fire(int a, int b);

enum Suund {YLES, YLES_PAREMALE, PAREMALE, ALLA_PAREMALE, ALLA, ALLA_VASAKULE, VASAKULE, YLES_VASAKULE};
bool liigu(int suund, bool tulista) {
    cout << "M" << suund << endl; // M5 liigu suunas alla-vasakule
    lts(); // info sisse, siin loetakse 
    if (tulista && nx == x && ny == y) { // kui ei liikunud (nx ja ny on uued koordinaadid)
        ok[y + dy[suund]][x + dx[suund]] = 1; // seal on keegi ees
        fire(suund, 6); // tulistan sinna
    }
    xnx(); // muudab x ja y vrtused
    return true;
}

void liiguTuleta(int suund) {
    liigu(suund, false);
}

bool liiguTulega(int suund) {
    return liigu(suund, true);
}

void liiguPoikle(int pSuund, int d) {
    cout << "M" << pSuund << endl; // liigub alla paremale
    lts();
    if (nx == x && ny == y) { //seal ka keegi ees
        ok[y + dy[pSuund]][x + dx[pSuund]] = 1;
        fire(pSuund, 6); //tulista
        int vSuund = (pSuund + d + 8) % 8;
        cout << "M" << vSuund << endl; //liigu paremale
        lts();
        if (nx == x && ny == y) {
            ok[y + dy[vSuund]][x + dx[vSuund]] = 1;
            fire(vSuund, 6); // tulista
            liiguTuleta((vSuund + d + 8) % 8);
            liiguTuleta(pSuund);
            return; // jtkan nurka minekut algusest peale (oma veerandis)
        }
        xnx(); //kui sai paremale, uued koordinaadid
        liiguTuleta(pSuund);
        return;
    }
    xnx(); //nnestus alla paremale
    return;
}

bool onLaual() {
    return (x > -1) && (x < m) && (y > -1) && (y < n);
}

bool onVaba(int suund){
    return !ok[y + dy[suund]][x + dx[suund]];
}

bool liiguNurgaSuunas(int nurkX, int nurkY, int suund){
    bool ol = 0;
    while (x != nurkX && y != nurkY && onVaba(suund)) { // liigume diagonaalis lhima nurga poole
        ol = liiguTulega(suund); //liigu alla vasakule (tulistamisega)
        
    }
    int xsuund = nurkX ? PAREMALE : VASAKULE;
    int ysuund = nurkY ? YLES : ALLA;
    bool fm = 1; // forsseeritud liikumine

    while (onLaual() && onVaba(xsuund) && (nurkX - x > nurkY - y || fm)) { // niikaua kui saab liikuda x telge mda serva poole
        ol = liiguTulega(xsuund); //liigu vasakule (tulistamisega)
        fm = 0;
    }
    
    fm = 1;
    while (onLaual() && onVaba(ysuund) && (nurkX - x < nurkY - y || fm)) { // kuni saab alla
        ol = liiguTulega(ysuund); //alla
        fm = 0;
    }
    return ol;
}

void poikle(int nurkX, int nurkY, int suund){
    int pSuund, d;
    if (!nurkX != !nurkY){
        pSuund = (suund + 2) % 8;
        d == 1;
    }
    else {
        pSuund = (suund + 6) % 8;
        d = -1;
    }

    if (nurkX - x < nurkY - y) { //leval vasakul vrreldes ige diagonaaliga
        liiguPoikle(pSuund, d);
    }
    else {
        liiguPoikle(leiaVastassuund(pSuund), -1*d);
    }
}

int leiaSuund(int x, int y) {
    if (x == 0 && y == 0) return ALLA_VASAKULE;
    if (x == 0) return YLES_VASAKULE;
    if (y == 0) return ALLA_PAREMALE;
    return YLES_PAREMALE;
}

int leiaVastassuund(int suund) {
    return (suund + 4) % 8;
}

int mineNurka(int nurkX, int nurkY) {
    int suund = leiaSuund(nurkX, nurkY);
    while (!ok[nurkY][nurkX] && (x != nurkX || y != nurkY)) { //ok - on keegi ees, sinna ei saa liikuda ja ise ei ole seal
        if (!liiguNurgaSuunas(nurkX, nurkY, suund)) { // kui ei ole ldse liikunud
            poikle(nurkX, nurkY, suund);
        }
    }
    return leiaVastassuund(suund);
}

int mineNurka() {
    int nurkX = (m - x > x) ? 0 : m - 1;
    int nurkY = (n - y > y) ? 0 : n - 1;
    return mineNurka(nurkX, nurkY);
}


