#include <algorithm>
#include <iostream>
#define ll long long

using namespace std;

long long delivery(int n, int k, int l, int p[])
{
    ll* ppAeg = new ll[n]; // meeskonnani paki viimise aeg ainult pripeva liikudes 
    ll* vpAeg = new ll[n]; // meeskonnani paki viimise aeg ainult vastupeva liikudes
    // leiame ajad iga meeskonnani ainult pripeva ja ainult vastupeva liikudes, arvestades, et eelnevad meeskonnad on suveniirid ktte saanud.
    for (int i = 0; i < n; i++) {
        if (i < k) { // esimesed k meeskonda mlemast otsast
            ppAeg[i] = p[i] * 2; // kime pripeva i.nda meeskonnani ja tagasi
            vpAeg[n-1-i] = (l - p[n-1-i]) * 2; // sama vastupeva 
        }
        else {
            int j = i - k; // meeskonna indeks, mis jb kindlasti eelmisesse jaotusesse
            ppAeg[i] = p[i] * 2 + ppAeg[j]; // eelmised jaotused + praeguse meeskonnani
            vpAeg[n-1-i] = (l - p[n-1-i]) * 2 + vpAeg[n-1-j]; //sama vastupeva
        }
    }
    ll vastus = 1e18; // vastuseks suur arv, otsime miinimumi
    
    if (n == k) { // suveniirid saab korraga kaasa vtta ja he ringiga jaotada.
        vastus = l; // sel moel on heks vimalikuks vastuseks sektorite arv.
    }

    // parim saab olla variant, kus jaotame kik vastupeva
    vastus = min(vastus, vpAeg[0]);  
    // vi ks tisring ja kik lejnud vastupeva
    vastus = min(vastus, vpAeg[k] + l);
    for (int i = 0; i < n; i++) {
        if (i == n - 1) {
            vastus = min(vastus, ppAeg[i]); // Kik meeskonnad pripeva jaotades
            continue;
        }
        // ainult edasi-tagasi jaotused: i. meeskonnani pripeva ja i+1. alates vastupeva.
        vastus = min(vastus, ppAeg[i] + vpAeg[i+1]);
        if (i + k + 1 == n) { // kui on ainult k meeskonda lpuni
            vastus = min(vastus, ppAeg[i] + l); // ks tisring + lejnud pripeva
        }
        else if (i + k + 1 < n) {
            // pripeva i.nda meeskonnani, siis tisring (k pakki/meeskonda) ja siis 
            // edasi alates meeskonnast i+k+1 vastupeva.
            vastus = min(vastus, ppAeg[i] + vpAeg[i+k+1] + l);
        }
    }
    return vastus;
}

int main()
{
    int N, K, L;
    cin >> N >> K >> L;
    int* P =  new int[N];
    for (int i = 0; i < N; i++) {
        cin >> P[i];
    }

    cout << delivery(N, K, L, P) << endl;
    return 0;
}

